var gm = require('./gm')

gm.prototype.parseFrame =
gm.prototype.parseFrames = function () {
  var frame = this.source.match(/(\[.+\])$/)
  if (!frame) {
    this.frame = null
  } else {
    this.frame = this.source.slice(frame.index, frame[0].length)
    this.source = this.source.slice(0, frame.index)
  }

  return this
}

gm.prototype.selectFrame =
gm.prototype.selectFrames = function (frame) {
  // Parse the frame if not yet parsed
  if (this.frame === undefined)
    this.parseFrame()

  // Unset frame
  if (frame === '' || frame === false || frame === null) {
    this.frame = null
    return this
  }

  // Convert to string
  if (typeof frame === 'number')
    frame = frame.toString()

  // Wrap around with brackets
  if (frame[0] !== '[')
    frame = '[' + frame
  if (frame[frame.length - 1] !== ']')
    frame += ']'

  this.frame = frame
  return this
}