var streamTo = require('stream-to')

var gm = require('./gm')

// Overwrite pipe, spawn process if not already
var pipe = gm.prototype.pipe
gm.prototype.pipe = function () {
  if (!this._process)
    this.convert()

  return pipe.apply(this, arguments)
}

// Add an optional format to the stdout output
gm.prototype.stream = function (format) {
  if (typeof format === 'string')
    this.output = format[format.length - 1] === '-'
      ? format
      : format + ':-'

  if (!this._process)
    this.convert()

  return this
}

// Return a buffer
gm.prototype.toBuffer = function (done) {
  if (!this._process)
    this.convert()

  var that = this

  streamTo.buffer(this._reader, function (err, buf) {
    done.call(that, err, buf)
  })

  return function (fn) {
    done = fn
  }
}

// Save to a file
gm.prototype.toFile = function (filename, done) {
  if (typeof filename !== 'string')
    throw new TypeError('Filename string is required.')

  this.output = filename

  if (!this._process)
    this.convert()

  var that = this

  that.once('error', finish)
  that.once('end', finish)

  function finish(err) {
    cleanup()
    done(err)
  }

  function cleanup() {
    that.removeListener('error', finish)
    that.removeListener('end', finish)
  }

  return function (fn) {
    done = fn
  }
}